# Import necessary packages
import os
import sys
import cv2
import numpy as np


# Declare the global weights
wt_1 =0
wt_2 =0
wt_3 =0
wt_4 =0
wt_5 =0
wt_6 =0
wt_7 =0
wt_8 =0
wt_9 =0
wt_10 =0
# Maximum weight
max_wt = 255
# To store the eigenvectors
eigenvectors=[]
# Declare mean image
mean_img = np.zeros((200,200,3), dtype = np.float32)



# Read images from the directory
def readImagePaths(path):
  # Create array of array of images.
  imagePaths = []
  # List all files in the directory and read points from text files one by one
  for filePath in sorted(os.listdir(path)):
    fileExt = os.path.splitext(filePath)[1]
    if fileExt in [".jpg", ".jpeg"]:
      print filePath

      # Add to array of images
      imagePaths.append(os.path.join(path, filePath))

  return imagePaths

# Add the weighted eigen faces to the mean face 
def calc_final_img():
	# The eigenvectors need to be reshaped into a 3 channel matrix of (200,200)
	eig1 = eigenvectors[0].reshape(200,200,3)*wt_1
	eig2 = eigenvectors[1].reshape(200,200,3)*wt_2
	eig3 = eigenvectors[2].reshape(200,200,3)*wt_3
	eig4 = eigenvectors[3].reshape(200,200,3)*wt_4
	eig5 = eigenvectors[4].reshape(200,200,3)*wt_5
	eig6 = eigenvectors[5].reshape(200,200,3)*wt_6
	eig7 = eigenvectors[6].reshape(200,200,3)*wt_7
	eig8 = eigenvectors[7].reshape(200,200,3)*wt_8
	eig9 = eigenvectors[8].reshape(200,200,3)*wt_9
	eig10 = eigenvectors[9].reshape(200,200,3)*wt_10
	# Adding the eigen faces to the output
	output = np.add(mean_img,eig1)
	output = np.add(output, eig2)
	output = np.add(output, eig3)
	output = np.add(output, eig4)
	output = np.add(output, eig5)
	output = np.add(output, eig6)
	output = np.add(output, eig7)
	output = np.add(output, eig8)
	output = np.add(output, eig9)
	output = np.add(output, eig10)
	output = np.float32(output)

	# Create window to show result
	cv2.namedWindow("Result", cv2.WINDOW_AUTOSIZE)
	cv2.imshow("Result", output)


# Updates weight 1
def update_1(*args):
    global wt_1
    wt_1 = args[0]
    calc_final_img()
    pass

# Updates weight 2
def update_2(*args):
    global wt_2
    wt_2 = args[0]
    calc_final_img()
    pass

# Updates weight 3
def update_3(*args):
    global wt_3
    wt_3 = args[0]
    calc_final_img()
    pass

# Updates weight 4
def update_4(*args):
    global wt_4
    wt_4 = args[0]
    calc_final_img()
    pass

# Updates weight 5
def update_5(*args):
    global wt_5
    wt_5 = args[0]
    calc_final_img()
    pass

# Updates weight 6
def update_6(*args):
    global wt_6
    wt_6 = args[0]
    calc_final_img()
    pass


# Updates weight 7
def update_7(*args):
    global wt_7
    wt_7 = args[0]
    calc_final_img()
    pass

# Updates weight 8
def update_8(*args):
    global wt_8
    wt_8 = args[0]
    calc_final_img()
    pass

# Updates weight 9
def update_9(*args):
    global wt_9
    wt_9 = args[0]
    calc_final_img()
    pass

# Updates weight 10
def update_10(*args):
    global wt_10
    wt_10 = args[0]
    calc_final_img()
    pass




if __name__ == '__main__':
	#Directory with images
	dirName = "../PCA/images"

	# Read image paths
	imagePaths = readImagePaths(dirName)
	if len(imagePaths) == 0:
		print('No images found with extension jpg or jpeg')
		sys.exit(0)

	images = []
	allPoints = []

	for imagePath in imagePaths:
		im = cv2.imread(imagePath)
		if im is None:
			print("image:{} not read properly".format(imagePath))
		else:
			# Resizing the image to 200x200
			im = cv2.resize(im,(200, 200), interpolation = cv2.INTER_CUBIC)
			im = np.float32(im)/255.0
			images.append(im)

	if(len(images)==0):
		print("No images found")
		sys.exit(0)


	# Initialize output
	output = np.zeros((200,200,3), dtype = np.float32)

	# Calculate mean image
	print("Calculating mean image...")
	for image in images:
		mean_img = np.add(mean_img, image)
	mean_img = np.multiply(mean_img, 1.0/len(images))
	print ("DONE")

	# Matrix_PCA will store the images in a stack for input to PCAcompute
	matrix_PCA =[]

	print ("Creating stack of images")
	# Subtract mean from first image
	images[0] = np.subtract(images[0], mean_img)
	# Reshape image from 200*200*3 to 1*120000
	images[0] = images[0].reshape(1,120000)
	#Initialize matrix_PCA
	matrix_PCA = images[0]

	#Create stack of images with the mean image subtracted from each
	for image in images[1:]:
		image = np.subtract(image, mean_img)
		image = image.reshape(1,120000)
		matrix_PCA = np.vstack((matrix_PCA, image))

	print("DONE")

	# Compute the eigenvectors from the stack of images created
	print("Calculating PCA(< 1 min)...")
	mean, eigenvectors = cv2.PCACompute(matrix_PCA, mean=np.array([]))
	print ("DONE")


	output = mean_img

	
	# Create window for displaying Mean Face
	cv2.namedWindow("Mean Face", cv2.WINDOW_AUTOSIZE)

	# Create Window for trackbars
	cv2.namedWindow("Trackbars1")

	# Show mean image first
	cv2.imshow("Mean Face", mean_img)

	# Create Trackbars
	cv2.createTrackbar( "Weight0", "Trackbars1", wt_1, max_wt, update_1)
	cv2.createTrackbar( "Weight1", "Trackbars1", wt_2, max_wt, update_2)
	cv2.createTrackbar( "Weight2", "Trackbars1", wt_3, max_wt, update_3)
	cv2.createTrackbar( "Weight3", "Trackbars1", wt_4, max_wt, update_4)
	cv2.createTrackbar( "Weight4", "Trackbars1", wt_5, max_wt, update_5)
	cv2.createTrackbar( "Weight5", "Trackbars1", wt_6, max_wt, update_6)
	cv2.createTrackbar( "Weight6", "Trackbars1", wt_7, max_wt, update_7)
	cv2.createTrackbar( "Weight7", "Trackbars1", wt_8, max_wt, update_8)
	cv2.createTrackbar( "Weight8", "Trackbars1", wt_9, max_wt, update_9)
	cv2.createTrackbar( "Weight9", "Trackbars1", wt_10, max_wt, update_10)

	
	cv2.waitKey(0)
	cv2.destroyAllWindows()




	
	


